#ifndef SQL_H
#define SQL_H
#include <sqlite3.h>
#include <random>
#include <string>
#include <openssl/sha.h>
#include <string.h>

unsigned char* sha256(const char* text) {
    unsigned int len = strlen ((const char*) text);
    unsigned char hash [32];
    SHA256((const unsigned char*)text, len, hash);
    unsigned char* output = hash;
    return output;
}

class pengoSQL {
public:
    sqlite3 *db;
    int response_code;
    char* response_message = 0;

    pengoSQL() {
        response_code = sqlite3_open("pbox.db", &db);
        if (response_code == SQLITE_OK) {
            response_code = sqlite3_exec(db, "CREATE TABLE IF NOT EXISTS Accounts(name TEXT PRIMARY KEY NOT NULL, password CHAR(32) NOT NULL, serial CHAR(16), email CHAR(255));", NULL, 0, &response_message);
        }

        if (!userExists("admin")) {
            std::mt19937 generator{std::random_device{}()};
            std::uniform_int_distribution<int> distribution{'a', 'z'};
            std::string pw(16, '\0');
            for(auto& dis: pw)
                dis = distribution(generator);
            if (createUser("admin", pw.c_str(), "0000000000000000")) printf("Admin user created.\n\tUsername: admin\n\tPassword: %s\n", pw.c_str());
            else printf("Error creating admin user.\n");
        }
    };

    bool userExists(const char* username) {
        sqlite3_stmt* stmt;
        sqlite3_prepare_v2(db, "SELECT * FROM Accounts WHERE username = ?;", -1, &stmt, 0);
        sqlite3_bind_text(stmt, 1, username, -1, NULL);
        int step = sqlite3_step(stmt);
        sqlite3_finalize(stmt);
        if (step == SQLITE_ROW) { return true; }
        return false;
    }

    bool createUser(const char* username, const char* password, const char* serial) {
        sqlite3_stmt* stmt;
        int result = sqlite3_prepare_v2(db, "INSERT INTO Accounts(name, password) VALUES (?, ?)", -1, &stmt, 0);
        sqlite3_bind_text(stmt, 1, username, -1, NULL);
        sqlite3_bind_text(stmt, 2, (const char*)sha256(password), -1, NULL);
        sqlite3_bind_text(stmt, 3, serial, -1, NULL);
        sqlite3_step(stmt);
        return result == SQLITE_DONE;
    }

    void close() { sqlite3_close(db); }
};

#endif
